[[anchor-appendix]]
== Appendix

The following chapters of the documentation are aimed at users with specialized knowledge on the inner workings of deegree.

NOTE: As the internal workings of deegree are always evolving, the information in these chapters might become obsolete without any prior notice. There is no guarantee for anything described in here to be the same for future versions of deegree.

=== Tunable deegree parameters

How to set up deegree is described in the chapter <<anchor-configuration-basics>> and following.
If it is required to change the default behavior of deegree in more specific use cases, this can be done through setting tunable deegree specific parameters.

These parameters can either be set through Java system property, for example when starting command line tools by adding the parameter in form of `-Dparameter=value`.
When deploying deegree webservices to existing Java Servlet container, these options can either be defined as system property or through JNDI environment definitions. 
footnote:[More details can be found in the Java tutorial on the topic of https://docs.oracle.com/javase/jndi/tutorial/beyond/env/source.html#SYS/[Specifying Environment Properties] or your Java Servlet container.]

.Example of JNDI environment

When using JNDI environment, more complex configurations are possible. For example, it is possible to limit the defined parameters to a specific deployment inside a Java Servlet container.

[source,xml]
----
<Environment name="deegree.rendering.stroke.miterlimit" value="2.66" 
             type="java.lang.Float" override="false" 
             description="deegree Rendering - Miter Limit Factor"/>
----
More details on the datails of configuration can be found inside the documentation of the used Java Servlet containter 
like https://tomcat.apache.org/tomcat-9.0-doc/config/context.html#Environment_Entries[Apache Tomcat].

.List of current available parameters

[width="100%",cols="20%,20%,10%,50%",options="header",]
|===
|Option |Type |Default Value |Description

|deegree.raster.cache.memsize |java.lang.String | |Size of memory that can be used to cache raster data in memory. By default, half of the memory available for the Java Process running deegree is used. 

|deegree.raster.cache.disksize |java.lang.String |20GiB |Defines the maximum amount of disk space that can be used for caching raster data on disk.
f
|deegree.raster.cache.iioreader |java.lang.Boolean |true |Enable caching of raster data at the reader level, enabled by default.

|deegree.protocol.wms.client.fallback |java.lang.Boolean |false |Fall back to the previously used `URLConnection` for requests to remote WMS servers, disabled by default.

|deegree.rendering.stroke.miterlimit |java.lang.Float |10 |When the configured factor is exceeded portrayal changes from JOIN_MITER to JOIN_BEVEL (see https://docs.oracle.com/javase/tutorial/2d/geometry/strokeandfill.html).

|deegree.sqldialect.oracle.export_oriented_point |java.lang.Boolean |false |Read the orientation of Oracle orientated points as additional properties, disabled by default. The properties are located in the deegree extraprop namespace `http://www.deegree.org/extraprop` and are named `orientation0`, `orientation1`, etc. 

|deegree.sqldialect.oracle.optimized_point_storage |java.lang.Boolean |true |Use optimized point storage for 2D points in oracle database.

|deegree.gdal.layer.limit_bands |java.lang.Boolean |false |If problems occur with data using four bands (e.g. including transparency or infrared), this option can be used to limit data access to the first three bands.

|deegree.cache.svgrenderer |java.lang.Integer |256 |Maximum number of rendered SVG images to be cached for speed

|deegree.rendering.svg-to-shape.previous |java.lang.Boolean |false |Enables the behavior of previously used versions when scaling SVG graphics for the rendering of strokes

|deegree.rendering.graphicstroke.svg-as-mark |java.lang.Boolean |false |Enables the previous behavior of rendering SVG graphics in `GraphicStroke`/`OnlineResource` like a Mark with the color of the `Stroke` instead of a rendered graphic.

|deegree.gml.property.simple.trim |java.lang.Boolean |true |When deegree reads GML data, by default (`true`) simple property values get their leading and trailing whitespace characters removed.

|deegree.config.apikey.warn-when-disabled |java.lang.Boolean |true |Log warning if security on REST api is disabled by specifying `*` in _config.apikey_.

|===

=== Interception points

deegree offers developers the ability to extend or change deegree with custom modules. 
This chapter is only intended as an entry point to make it easier to reach these Java service provider interfaces.

[width="100%",cols="40%,40%,10%",options="header",]
|===
|Service provider interface |Examplary implementation |Cardinality

|org.deegree.sqldialect.SQLDialectProvider |org.deegree.sqldialect.postgis.PostGISDialectProvider |0..*

|org.deegree.style.styling.mark.WellKnownNameLoader |org.deegree.style.styling.wkn.ShapeLoader |0..*

|org.deegree.filter.function.FunctionProvider |org.deegree.filter.function.other.Lower |1..*

|org.deegree.sqldialect.filter.function.SQLFunctionProvider |org.deegree.sqldialect.filter.function.SQLLower |1..*

|org.deegree.filter.expression.custom.CustomExpression |org.deegree.filter.expression.custom.se.Substring |1..*

|org.deegree.services.controller.exception.serializer.SerializerProvider | |0..*

|org.deegree.services.csw.getrecordbyid.GetRecordByIdHandler |org.deegree.services.csw.getrecordbyid.DefaultGetRecordByIdHandler |0..1

|org.deegree.tools.featurestoresql.loader.FeatureStreamFactory | |0..*

|org.deegree.coverage.raster.data.container.MemoryRasterDataContainer |org.deegree.coverage.raster.data.container.MemoryRasterDataContainer |1..*

|org.deegree.services.wms.controller.plugins.OutputFormatProvider |org.deegree.services.wms.controller.plugins.DefaultOutputFormatProvider |0..1

|org.deegree.services.wms.controller.plugins.GetFeatureInfoProvider |org.deegree.services.wms.controller.plugins.DefaultGetFeatureInfoProvider |0..1

|===

[[anchor-appendix-customconverter]]
=== Custom converters for the SQL feature store

Custom converters provide an extension point for plugins to provide a specialized DB-to-ObjectModel converter implementation.

The configuration is not defined as an XML schema, but consists of the specification of the class and an optional list of parameters, 
which in turn consist of keys and values. 

A configuration might look something like this:

[source,xml]
----
<CustomConverter class="com.example.CustomConverter">
    <Param name="color">RED</Param>
    <Param name="size">42</Param>
</CustomConverter>
----

The following table lists converter that are already available for use or as a reference.

[width="100%",cols="35%,15%,40%",options="header",]
|===
|Class |Parameter |Description

|org.deegree.feature.persistence.sql.converter.BinaryBase64PrimitiveConverter |  |Converts binary database columns from/to primitive strings encoded as Base64 (RFC 4648)
|  |max-length |The maximum length of allowed data is limited to prevent Denial of Service Attacks. Specified in bytes and defaults to 256 MiB.

|org.deegree.feature.persistence.sql.converter.BinaryDataUrlPrimitiveConverter |  |Converts binary database columns from/to primitive strings encoded as data URL (RFC 2397)
|  |max-length |The maximum length of allowed data is limited to prevent Denial of Service Attacks. Specified in bytes and defaults to 256 MiB.
|  |magic-XX |Mime type for records which data start with the magic numbers  (`XX`) encoded as a hexadecimal value. The converter contains some common magic numbers for PNG, JPEG and GIF.

|org.deegree.feature.persistence.sql.converter.CharacterPrimitiveConverter |  |Converts large character type database columns from/to primitive strings
|  |max-length |The maximum length of allowed data is limited to prevent Denial of Service Attacks. Specified in bytes and defaults to 256 MiB.

|===

Here's an example:

[source,xml]
----
<FeatureTypeMapping table="TABLENAME" name="LargeObjectFeature">
    <!-- ... -->
    <Primitive mapping="IMAGE" path="image" type="string">
        <CustomConverter class="org.deegree.feature.persistence.sql.converter.BinaryDataUrlPrimitiveConverter">
            <Param name="magic-424D">image/bmp</Param>
        </CustomConverter>
    </Primitive>
</FeatureTypeMapping>
----